## gridtools 1.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12.4)

cmake_policy(SET CMP0048 NEW)
file(STRINGS "version.txt" __GT_VERSION)
project(GridTools VERSION ${__GT_VERSION} LANGUAGES CXX)
unset(__GT_VERSION)

list (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

include(CTest)

# ===============
# Load some cmake modules.
# 1) define what flags should be available,

include(detect_features)
detect_cuda()
detect_openmp()
detect_mpi()

include (flags)

if(POLICY CMP0060)
  # Policy to avoid cmake to substitute libraries with paths and extensions with -l<libname>
  cmake_policy(SET CMP0060 NEW)
endif()

# ===============
# Load some cmake modules.
# 2) package by name finder
# 3) testing methods
# 4) build configurator (include path, compiler flags, etc.
# ===============
include (definitions)
if (BUILD_TESTING)
    include (testing)
endif()
include (bindings)
include (components)

# TODO this install targets are not finished on purpose.
if( COMPONENT_COMMON )
    install(TARGETS gridtools EXPORT GridToolstargets
      LIBRARY DESTINATION lib
      ARCHIVE DESTINATION lib
      RUNTIME DESTINATION bin
      INCLUDES DESTINATION include
    )
    install(EXPORT GridToolstargets
      FILE GridToolsTargets.cmake
      NAMESPACE gridtools::
      DESTINATION ${INSTALL_CONFIGDIR}
    )

    generate_target_for(NAME common)
    target_link_libraries(common INTERFACE gridtools)
endif()

if( COMPONENT_BOUNDARY_CONDITIONS )
    generate_target_for(NAME boundary_conditions)
    target_link_libraries( boundary_conditions INTERFACE common )
endif()

if( COMPONENT_STENCIL_COMPOSITION )
    generate_target_for(NAME stencil_composition)
    target_link_libraries( stencil_composition INTERFACE common )
endif()

if( COMPONENT_GCL )
    generate_target_for(NAME gcl SOURCES src/GCL.cpp include/gridtools/communication/GCL.hpp include/gridtools/communication/high_level/stats_collector.hpp )
    target_link_libraries(gcl gridtools)
    if( GT_USE_MPI )
        target_link_libraries(gcl MPI::MPI_CXX)
    endif()
endif()

if( COMPONENT_DISTRIBUTED_BOUNDARIES )
    generate_target_for(NAME distributed_boundaries)
    target_link_libraries( distributed_boundaries INTERFACE boundary_conditions gcl )
endif()

if( COMPONENT_STORAGE )
    generate_target_for(NAME storage)
    target_link_libraries( distributed_boundaries INTERFACE common )
endif()

if( COMPONENT_INTERFACE )
    generate_target_for(NAME interface)
endif()

if( COMPONENT_TOOLS )
    generate_target_for(NAME tools)
endif()

if(COMPONENT_C_BINDINGS)
    generate_target_for(NAME c_bindings)
endif()

# ===============
# tests
# ===============
if(BUILD_TESTING)
  # TODO move to the right directory
  add_library(regression_main src/tools/regression_fixture.cpp)
  target_link_libraries(regression_main gtest gridtools)

  add_subdirectory(regression)
  add_subdirectory(unit_tests)
  
  add_subdirectory(docs_src/manuals/getting_started)
endif()

# ===============
# examples
# ===============
if(GT_INSTALL_EXAMPLES)
    add_subdirectory(examples)
endif()

# ===============
# Downloads the gridtools_experimental repository
# ===============
if(GT_ENABLE_EXPERIMENTAL_REPOSITORY)
  include(gridtools_experimental/download_gridtools_experimental)
endif()

# ===============
# Python scripts
# ===============
if(GT_ENABLE_PYUTILS)
    add_subdirectory(pyutils)
endif()

include(export)

=== examples/CMakeLists.txt ===
# This file is part of the GridTools source tree to drive installation of the examples.

function(install_example)
    set(options)
    # - if needed later split into mc and cuda sources (then add extension)
    set(one_value_args DIRECTORY)
    set(multi_value_args SOURCES)
    cmake_parse_arguments(ARG "${options}" "${one_value_args};" "${multi_value_args}" ${ARGN})

    string(REPLACE ";" " " EXAMPLES_SRCFILES "${ARG_SOURCES}")
    configure_file(cmake_skeletons/CMakeLists.txt.example.in ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${ARG_DIRECTORY}/CMakeLists.txt @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${ARG_DIRECTORY}/CMakeLists.txt DESTINATION ${GT_INSTALL_EXAMPLES_PATH}/${ARG_DIRECTORY})
    install(
        DIRECTORY ${ARG_DIRECTORY}
        DESTINATION ${GT_INSTALL_EXAMPLES_PATH}
        )

    list(APPEND enabled_examples ${ARG_DIRECTORY})
    set(enabled_examples ${enabled_examples} PARENT_SCOPE)
endfunction()

if(GT_INSTALL_EXAMPLES)
    set(enabled_examples) # used in CMakeLists.txt.in, filled in install_example()
    if(COMPONENT_STENCIL_COMPOSITION)
        install_example(DIRECTORY stencil_composition SOURCES copy_stencil horizontal_diffusion_limited tridiagonal_solver)
    endif()

    if(COMPONENT_BOUNDARY_CONDITIONS)
        install_example(DIRECTORY boundary_conditions SOURCES boundary_conditions boundary_conditions_provided)
    endif()

    if(COMPONENT_C_BINDINGS)
        configure_file(c_bindings/CMakeLists.txt.in
            ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/c_bindings/CMakeLists.txt @ONLY)
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/c_bindings/CMakeLists.txt
            DESTINATION ${GT_INSTALL_EXAMPLES_PATH}/c_bindings)
        install(
            DIRECTORY c_bindings
            DESTINATION ${GT_INSTALL_EXAMPLES_PATH}
            PATTERN "CMakeLists.txt.in" EXCLUDE
            )
        list(APPEND enabled_examples c_bindings)
    endif()

    configure_file(cmake_skeletons/CMakeLists.txt.driver.in ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeLists.txt @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeLists.txt DESTINATION ${GT_INSTALL_EXAMPLES_PATH})

    install(FILES ${CMAKE_SOURCE_DIR}/cmake/workaround_check_language.cmake DESTINATION ${GT_INSTALL_EXAMPLES_PATH})
endif()

=== pyutils/CMakeLists.txt ===
string(TOLOWER "${CMAKE_BUILD_TYPE}" PYUTILS_BUILD_TYPE)

if(GT_ENABLE_BACKEND_CUDA)
    set(PYUTILS_COMPILER "${CMAKE_CUDA_COMPILER} ${CMAKE_CUDA_COMPILER_VERSION} (${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_VERSION})")
else()
    set(PYUTILS_COMPILER "${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_VERSION}")
endif()

if(GT_SINGLE_PRECISION)
    set(PYUTILS_PRECISION "float")
else()
    set(PYUTILS_PRECISION "double")
endif()

if(GT_TESTS_ICOSAHEDRAL_GRID)
    set(PYUTILS_GRID "icosahedral")
else()
    set(PYUTILS_GRID "structured")
endif()

if(GT_ENABLE_BACKEND_X86)
    list(APPEND PYUTILS_BACKEND "x86")
endif()

if(GT_ENABLE_BACKEND_NAIVE)
    list(APPEND PYUTILS_BACKEND "naive")
endif()

if(GT_ENABLE_BACKEND_CUDA)
    list(APPEND PYUTILS_BACKEND "cuda")
endif()

if(GT_ENABLE_BACKEND_MC)
    list(APPEND PYUTILS_BACKEND "mc")
endif()

file(COPY . DESTINATION . FILES_MATCHING PATTERN *.py)
configure_file(pyutils/buildinfo.py.in pyutils/buildinfo.py)

=== regression/CMakeLists.txt ===
if( COMPONENT_STENCIL_COMPOSITION )

    if(GT_TESTS_ICOSAHEDRAL_GRID)
        add_subdirectory(icosahedral)
    else()

      set(SOURCES_PERFTEST
          horizontal_diffusion
          horizontal_diffusion_fused
          simple_hori_diff
          copy_stencil
          vertical_advection_dycore
          advection_pdbott_prepare_tracers
          )
      set(SOURCES
          ${SOURCES_PERFTEST}
          boundary_condition
          laplacian positional_stencil
          tridiagonal
          alignment
          extended_4D
          expandable_parameters
          expandable_parameters_single_kernel
          horizontal_diffusion_functions
          )

      # special target for executables which are used from performance benchmarks
      add_custom_target(perftests)

      if(GT_ENABLE_BACKEND_X86)
        foreach(srcfile IN LISTS SOURCES)
          add_executable(${srcfile}_x86 ${srcfile}.cpp)
          target_link_libraries(${srcfile}_x86 regression_main GridToolsTestX86)

          gridtools_add_test(
              NAME tests.${srcfile}_x86_12_33_61
              COMMAND $<TARGET_FILE:${srcfile}_x86> 12 33 61
              LABELS regression_x86 backend_x86
              )
          gridtools_add_test(
              NAME tests.${srcfile}_x86_23_11_43
              COMMAND $<TARGET_FILE:${srcfile}_x86> 23 11 43
              LABELS regression_x86 backend_x86
              )

          if (srcfile IN_LIST SOURCES_PERFTEST)
              add_dependencies(perftests ${srcfile}_x86)
          endif()
        endforeach(srcfile)

        if( GT_USE_MPI )
            add_custom_mpi_test(x86 TARGET copy_stencil_parallel NPROC 4 SOURCES copy_stencil_parallel.cpp)

            ## The next executable is not made into a test since it does not validate.
            ## The numerics need to be fixed (this is a task to be undertaken in the future)
            add_executable(shallow_water_enhanced_x86  shallow_water_enhanced.cpp)
            target_link_libraries(shallow_water_enhanced_x86 gtest_main gcl GridToolsTestX86)
        endif()
      endif(GT_ENABLE_BACKEND_X86)

      if(GT_ENABLE_BACKEND_NAIVE)
        foreach(srcfile IN LISTS SOURCES)
          add_executable(${srcfile}_naive   ${srcfile}.cpp)
          target_link_libraries(${srcfile}_naive regression_main GridToolsTestNAIVE)

          gridtools_add_test(
              NAME tests.${srcfile}_naive_12_33_61
              COMMAND $<TARGET_FILE:${srcfile}_naive> 12 33 21
              LABELS regression_naive backend_naive
              )
          gridtools_add_test(
              NAME tests.${srcfile}_naive_23_11_43
              COMMAND $<TARGET_FILE:${srcfile}_naive> 23 11 43
              LABELS regression_naive backend_naive
              )
        endforeach(srcfile)

        if( GT_USE_MPI )
            add_custom_mpi_test(naive TARGET copy_stencil_parallel NPROC 4 SOURCES copy_stencil_parallel.cpp)

            ## The next executable is not made into a test since it does not validate.
            ## The numerics need to be fixed (this is a task to be undertaken in the future)
            add_executable(shallow_water_enhanced_naive  shallow_water_enhanced.cpp)
            target_link_libraries(shallow_water_enhanced_naive gtest_main gcl GridToolsTestNAIVE)
        endif()
      endif(GT_ENABLE_BACKEND_NAIVE)

      if(GT_ENABLE_BACKEND_MC)
        foreach(srcfile IN LISTS SOURCES)
          add_executable(${srcfile}_mc   ${srcfile}.cpp)
          target_link_libraries(${srcfile}_mc regression_main GridToolsTestMC)

          gridtools_add_test(
              NAME tests.${srcfile}_mc_12_33_61
              COMMAND $<TARGET_FILE:${srcfile}_mc> 12 33 61
              LABELS regression_mc backend_mc
              )
          gridtools_add_test(
              NAME tests.${srcfile}_mc_23_11_43
              COMMAND $<TARGET_FILE:${srcfile}_mc> 23 11 43
              LABELS regression_mc backend_mc
              )
          if (srcfile IN_LIST SOURCES_PERFTEST)
            add_dependencies(perftests ${srcfile}_mc)
          endif()
        endforeach(srcfile)

        if( GT_USE_MPI )
            add_custom_mpi_test(mc TARGET copy_stencil_parallel NPROC 4 SOURCES copy_stencil_parallel.cpp)

            ## The next executable is not made into a test since it does not validate.
            ## The numerics need to be fixed (this is a task to be undertaken in the future)
            add_executable(shallow_water_enhanced_mc  shallow_water_enhanced.cpp)
            target_link_libraries(shallow_water_enhanced_mc  gtest_main gcl GridToolsTestMC)
        endif()
    endif(GT_ENABLE_BACKEND_MC)

    if(GT_ENABLE_BACKEND_CUDA)

       foreach(srcfile IN LISTS SOURCES)
           add_executable( ${srcfile}_cuda ${srcfile}.cu)
           target_link_libraries(${srcfile}_cuda regression_main GridToolsTestCUDA)

           gridtools_add_test(
               NAME tests.${srcfile}_cuda_47_38_61
               COMMAND $<TARGET_FILE:${srcfile}_cuda> 47 38 61
               LABELS regression_cuda backend_cuda
               )
           gridtools_add_test(
               NAME tests.${srcfile}_cuda_63_38_10
               COMMAND $<TARGET_FILE:${srcfile}_cuda> 63 38 10
               LABELS regression_cuda backend_cuda
               )
           if (srcfile IN_LIST SOURCES_PERFTEST)
             add_dependencies(perftests ${srcfile}_cuda)
           endif()

           if (GT_CUDA_PTX_GENERATION)
               add_library( ${srcfile}_cuda_ptx OBJECT ${srcfile}.cu)
               target_link_libraries(${srcfile}_cuda_ptx regression_main GridToolsTestCUDA)
               set_target_properties(${srcfile}_cuda_ptx PROPERTIES CUDA_PTX_COMPILATION ON)
           endif()
       endforeach(srcfile)

       if( GT_USE_MPI )
           add_custom_mpi_test(cuda TARGET copy_stencil_parallel NPROC 4 SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/copy_stencil_parallel.cu )

           ## The next executable is not made into a test since it does not validate.
           ## The numerics need to be fixed (this is a task to be undertaken in the future)
           add_executable(shallow_water_enhanced_cuda shallow_water_enhanced.cu)
           target_link_libraries(shallow_water_enhanced_cuda gtest_main gcl GridToolsTestCUDA)
        endif()
    endif(GT_ENABLE_BACKEND_CUDA)

    if ( COMPONENT_C_BINDINGS )
        add_subdirectory( c_bindings )
    endif()

    if ( COMPONENT_GCL )
        add_subdirectory( communication )
    endif()

  endif(GT_TESTS_ICOSAHEDRAL_GRID)
endif( COMPONENT_STENCIL_COMPOSITION )

=== unit_tests/CMakeLists.txt ===
# collect tests
fetch_x86_tests(. LABELS unittest_x86)
fetch_gpu_tests(. LABELS unittest_cuda)

# include all subdirs
if ( COMPONENT_COMMON )
   add_subdirectory( common )
endif()
if ( COMPONENT_GCL )
   add_subdirectory( communication )
endif()
if ( COMPONENT_BOUNDARY_CONDITIONS )
   add_subdirectory( boundary_conditions )
endif()

if ( COMPONENT_DISTRIBUTED_BOUNDARIES )
   add_subdirectory( distributed_boundaries )
endif()
if ( COMPONENT_STENCIL_COMPOSITION )
   add_subdirectory( stencil_composition )
endif()
if ( COMPONENT_STORAGE )
   add_subdirectory( storage )
endif()

if ( COMPONENT_C_BINDINGS )
   add_subdirectory( interface )
   add_subdirectory( c_bindings )
endif()

=== regression/c_bindings/CMakeLists.txt ===
if (GT_ENABLE_BACKEND_X86)
    if(GT_SINGLE_PRECISION)
        set(prec float)
    else()
        set(prec double)
    endif()

    gt_add_bindings_library(implementation_${prec} SOURCES implementation.cpp FORTRAN_MODULE_NAME implementation)
    target_link_libraries(implementation_${prec} PUBLIC GridToolsTestX86)
    gt_add_bindings_library(implementation_wrapper_${prec} SOURCES implementation_wrapper.cpp FORTRAN_MODULE_NAME implementation_wrapper)
    target_link_libraries(implementation_wrapper_${prec} PUBLIC GridToolsTestX86)

    if (CMAKE_C_COMPILER_LOADED)
        add_executable(driver driver.c)
        target_link_libraries(driver implementation_${prec}_c)
    endif()

    if (CMAKE_Fortran_COMPILER_LOADED)
        include(fortran_helpers)

        add_executable(fdriver fdriver.f90)
        target_link_libraries(fdriver implementation_${prec}_fortran)
        set_target_properties(fdriver PROPERTIES LINKER_LANGUAGE Fortran)
        gt_enable_fortran_preprocessing_on_target(fdriver)

        add_executable(fdriver_wrapper fdriver_wrapper.f90)
        target_link_libraries(fdriver_wrapper implementation_wrapper_${prec}_fortran)
        set_target_properties(fdriver_wrapper PROPERTIES LINKER_LANGUAGE Fortran)
        gt_enable_fortran_preprocessing_on_target(fdriver_wrapper)
    endif()
endif(GT_ENABLE_BACKEND_X86)

=== unit_tests/c_bindings/CMakeLists.txt ===
# collect all tests in current folder
fetch_x86_tests(. LABELS unittest_x86)
fetch_gpu_tests(. LABELS unittest_cuda)

=== docs_src/manuals/getting_started/CMakeLists.txt ===
if (NOT GT_TESTS_ICOSAHEDRAL_GRID)
    function(add_getting_started_test)
        set(options)
        set(one_value_args SOURCE SUFFIX)
        cmake_parse_arguments(ARG "${options}" "${one_value_args}" "${multi_value_args}" ${ARGN})

        get_filename_component(_name ${ARG_SOURCE} NAME_WE)
        set(test_name getting_started_${_name}${ARG_SUFFIX})

        add_executable(${test_name} ${ARG_SOURCE})
        target_link_libraries(${test_name} GridToolsTest)

        gridtools_add_test(
            NAME ${test_name}
            COMMAND $<TARGET_FILE:${test_name}>
            LABELS getting_started
            )
    endfunction()

    file(GLOB getting_started_sources "code/test_*.cpp")
    foreach(test_source IN LISTS getting_started_sources)
        add_getting_started_test(SOURCE ${test_source} SUFFIX "")
    endforeach()

    if(GT_ENABLE_BACKEND_CUDA)
        file(GLOB getting_started_sources "code/test_*.cu")
        foreach(test_source IN LISTS getting_started_sources)
            add_getting_started_test(SOURCE ${test_source} SUFFIX "_cuda")
        endforeach()
    endif()

    # Test the CMake example file
    # The generated file should be part of the repository to be able to build the docs without having to run CMake.
    configure_file(code/CMakeLists.txt.in ${CMAKE_CURRENT_LIST_DIR}/code/CMakeLists.txt @ONLY)

    include(ExternalProject)
    ExternalProject_Add(getting_started_cmake_test
        DOWNLOAD_COMMAND ""
        SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR}/code
        CMAKE_ARGS
            -DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}
            -DGridTools_DIR=${CMAKE_BINARY_DIR} # relies on the GridToolsConfig.cmake in the build directory (the one used for export(package))
        INSTALL_COMMAND ""
    )
endif()

=== unit_tests/interface/repository/CMakeLists.txt ===
# The following macro is a trick to generate a file containing pre-processed compiler output (-E flag)
macro(generate_preprocessed_file preprocessed_file_out cpp_file)
    # check if ${cpp_file} is a file that exists (to protect that the user passes in multiple files or something else)
    if( EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${cpp_file}" )
        # pretend to generate an object file ...
        add_library( ${cpp_file}_OBJECTS OBJECT EXCLUDE_FROM_ALL ${cpp_file} )
        # ... but actually generate the preprocessed file
        target_compile_options( ${cpp_file}_OBJECTS BEFORE PUBLIC -E ${GT_CXX_FLAGS})
        target_link_libraries( ${cpp_file}_OBJECTS common )

        # add a target for the generated file
        add_custom_command( OUTPUT ${preprocessed_file_out}
            COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_OBJECTS:${cpp_file}_OBJECTS> ${preprocessed_file_out}
            DEPENDS ${cpp_file}_OBJECTS $<TARGET_OBJECTS:${cpp_file}_OBJECTS>
            COMMENT "Extract generated code"
            )

        get_filename_component(generated_target_name ${preprocessed_file_out} NAME_WE)
        add_custom_target(${generated_target_name}
            DEPENDS ${preprocessed_file_out}
            )
    else()
        message( ERROR "In macro generate_preprocessed_file: ${cpp_file} is not a file" )
    endif()
endmacro(generate_preprocessed_file)

if (GT_ENABLE_BACKEND_X86)
    # generate a file where we can inspect the generated repository
    set( GENERATED_REPOSITORY ${CMAKE_CURRENT_BINARY_DIR}/generated_repository.cpp )
    generate_preprocessed_file( ${GENERATED_REPOSITORY} plain_repository_generator.cpp )

    # clean the preprocessed file from comments and from everything before our class starts
    add_custom_command(OUTPUT ${GENERATED_REPOSITORY}
      # remove all lines starting with '#'
      # remove everything before "class my_repository"
      COMMAND sed "/^#/d" ${GENERATED_REPOSITORY} | awk "/class my_repository/,0" > ${GENERATED_REPOSITORY}_tmp
      COMMAND cp ${GENERATED_REPOSITORY}_tmp ${GENERATED_REPOSITORY}
      APPEND
      )

    # format the generated file if we can
    if( CLANG_FORMAT_FOUND )
        add_custom_command(OUTPUT ${GENERATED_REPOSITORY}
            COMMAND ${CLANG_FORMAT_BIN} -i ${GENERATED_REPOSITORY}
            APPEND
      )
    endif()

    # generate the driver
    configure_file( custom_test_generated_repository.cpp.in ${CMAKE_CURRENT_BINARY_DIR}/custom_test_generated_repository.cpp )

    add_executable( custom_test_generated_repository ${CMAKE_CURRENT_BINARY_DIR}/custom_test_generated_repository.cpp )
    target_link_libraries(custom_test_generated_repository gtest_main GridToolsTestX86 )
    gridtools_add_test(
        NAME custom_test_generated_repository
        COMMAND $<TARGET_FILE:custom_test_generated_repository>
        LABELS unittest_x86 backend_x86
        )
    add_dependencies(custom_test_generated_repository generated_repository)
endif()

# collect test cases
fetch_x86_tests(. LABELS unittest_x86 )
fetch_gpu_tests(. LABELS unittest_cuda )
fetch_mc_tests(. LABELS unittest_mc )

if(GT_SINGLE_PRECISION)
    set(prec float)
else()
    set(prec double)
endif()

gt_add_bindings_library(repository_${prec} SOURCES exported_repository.cpp FORTRAN_MODULE_NAME repository)
target_link_libraries(repository_${prec} PUBLIC gridtools gtest)
if(GT_SINGLE_PRECISION)
    target_compile_definitions(repository_${prec} PUBLIC GT_FLOAT_PRECISION=4)
else()
    target_compile_definitions(repository_${prec} PUBLIC GT_FLOAT_PRECISION=8)
endif()

if (CMAKE_Fortran_COMPILER_LOADED)
    include(fortran_helpers)

    add_library(repository_fortran_lib test_repository.f90)
    target_link_libraries(repository_fortran_lib repository_${prec}_fortran)
    gt_enable_fortran_preprocessing_on_target(repository_fortran_lib)

    if (GT_ENABLE_BACKEND_X86)
        add_custom_test(
            x86
            TARGET custom_test_exported_repository
            SOURCES custom_test_exported_repository.cpp
            LABELS unittest_x86
            )
        target_link_libraries(custom_test_exported_repository_x86
            repository_fortran_lib
            )
    endif()
    # TODO Fix this test. This test does not work right now because repository_${proc}_fortran
    # is not compiled with ACC. ACC cannot be activated for CUDA 8.X because it requires
    # gfortran <= 5.X
    # if (GT_ENABLE_BACKEND_CUDA)
        # add_custom_test(
            # cuda
            # TARGET custom_test_exported_repository
            # SOURCES custom_test_exported_repository.cpp
            # LABELS unittest_cuda
            # )
        # target_link_libraries(custom_test_exported_repository_cuda
            # repository_fortran_lib
            # )
    # endif()
    if (GT_ENABLE_BACKEND_MC AND NOT GT_ENABLE_BACKEND_X86)
        add_custom_test(
            mc
            TARGET custom_test_exported_repository
            SOURCES custom_test_exported_repository.cpp
            LABELS unittest_mc
            )
        target_link_libraries(custom_test_exported_repository_mc
            repository_fortran_lib
            )
    endif()


endif()

=== docs_src/manuals/getting_started/code/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12.4)

project(GridTools-laplacian LANGUAGES CXX)

find_package(GridTools 1.0.1 REQUIRED)

add_executable(gt_laplacian test_gt_laplacian.cpp)
target_link_libraries(gt_laplacian GridTools::gridtools)

=== debian/changelog ===
gridtools (1.0.2-2) unstable; urgency=medium

  * Reupload with source upload
  * Standards-Version: 4.4.1.0

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 30 Dec 2019 08:14:40 +0000

gridtools (1.0.2-1) unstable; urgency=medium

  * Initial release. (Closes: #935264)
  * re-done with Apache license referenced in d/copyright

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 08 Dec 2019 15:26:03 +0000

=== debian/control ===
Source: gridtools
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 12), 
  dh-buildinfo, 
  cmake,
  gfortran | fortran-compiler,
  doxygen,
  mpi-default-dev,
  libboost-dev
Standards-Version: 4.4.1.0
Homepage: https://software.ecmwf.int/wiki/display/ECC/ecCodes+Home
Vcs-Browser: https://salsa.debian.org:/science-team/gridtools.git
Vcs-Git: https://salsa.debian.org:/science-team/atlas-ecmwf.git

Package: libgridtools-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Framework for storage and computation on Weather and Climate Grids
 The GridTools (GT) framework is a set of libraries and utilities to develop
 performance portable applications in which stencil operations on grids are
 central.  It provides regular and block-structured grids commonly found in the
  weather and climate application field, addresses the challenges that arise
 from integration into production code, such as the expression of boundaryi
 conditions, or conditional execution. The framework is structured such that
 it can be called from different weather models or programming interfaces,
 and can target various computer architectures. This is achieved by separating
 the GT core library in a user facing part (frontend) and architecture specific
 (backend) parts. The core library also abstracts various possible data layouts
 and applies optimizations on stages with multiple stencils.
 The core library is complemented by facilities to interoperate with other 
 languages (such as C and Fortran), to aid code development and a communication
 layer.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
INSTDIR:=debian/libgridtools-dev
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

BUILD_FLAGS = \
	-DCMAKE_MODULE_PATH=/usr/share/ecbuild/cmake \
	-DENABLE_GRIDTOOLS_STORAGE=On 

# Test suite requires 4 processors. Fake it on OpenMPI
export OMPI_MCA_rmaps_base_oversubscribe=1

%:
	dh $@ --buildsystem=cmake 

override_dh_auto_configure:
	dh_auto_configure -- ${BUILD_FLAGS} 


override_dh_auto_install:
	dh_auto_install
	# Shuffle to correct locations
	install -d $(INSTDIR)/$(LIBDIR)/cmake
	install -d $(INSTDIR)/usr/share/doc/libgridtools-dev
	mv $(INSTDIR)/usr/lib/libgcl.a $(INSTDIR)/$(LIBDIR)
	mv $(INSTDIR)/usr/lib/cmake $(INSTDIR)/$(LIBDIR)/cmake/gridtools
	mv $(INSTDIR)/usr/gridtools_examples $(INSTDIR)/usr/share/doc/libgridtools-dev
	mv $(INSTDIR)/usr/src/c_bindings	$(INSTDIR)/usr/share/doc/libgridtools-dev

## gridtools 1.1.2

=== debian/changelog ===
gridtools (1.1.2-1) unstable; urgency=medium

  * New upstream release
  * Add mipsel to list of non -march=native architectures
  * Don't include cpp_bindgen as it requires a pull from git external
    project

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 08 Jan 2020 09:16:10 +0000

gridtools (1.0.2-3) unstable; urgency=medium

  * Use ecbuild now instead of cmake
  * Set -DGT_ENABLE_BACKEND_X86-Off -DGT_ENABLE_BACKEND_NAIVE=Off to ensure
    -march=native not used on archs where it FTBFS
  * Drop ${shlibs:Depends} in bin package as it provides static archives only
  * Fix homepage to gridtools.github.io
  * libgridtools-dev requires mpi, ecbuild to compile

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 05 Jan 2020 12:54:10 +0000
